﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Globalization;
using System.Collections;

/// <summary>
/// Summary description for ApplicationServer
/// </summary>
public sealed class ApplicationServer
{
    static ApplicationServer instance = null;
    static readonly object padlock = new object();
    
    private BibsysAdapter bibAdapt;
    private BusAdapter busAdapt;
    public Hashtable applicationLibraryHash;
	
    public static ApplicationServer Instance{
        get{
            lock(padlock)
            {
                if(instance==null)
                {
                    instance = new ApplicationServer();
                }
                return instance;
            }
        }
    }

    ApplicationServer()
	{
        //Creates the adapter communicating with BIBSYS
        bibAdapt = new BibsysAdapter();
        busAdapt = new BusAdapter();
	}

    /// <summary>
    /// 
    /// </summary>
    /// <param name="keyword"></param>
    public string documentSearch(string keyword, string lat, string lon)
    {
        //The search also returns the results for libraries not in Trondheim
        string queryResultString = bibAdapt.queryForDocument(keyword, lat, lon);
        applicationLibraryHash = bibAdapt.libraryHash;
        return queryResultString;
    }

    public string[] busSearch(string from, string to)
    {
        string[] returnArray = busAdapt.queryBusSchedule(from, to);
        return returnArray;
    }
}
