﻿using System;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.IO;
using System.Net;
using System.Text;
using System.Windows.Forms;
using System.Threading;


public partial class _Default : System.Web.UI.Page
{
    // API key
    //static readonly String API_KEY = "ABQIAAAAzEMobmJ-xNOj9NJ4pihr-BR6cq_b0mgmQhklwi3eKCPqHf3EqRRFz7J5yONHdCnCdVDDmQjNvrDdug";
    //napp.fiskekulpen.com API key
    static readonly String API_KEY = "ABQIAAAAzEMobmJ-xNOj9NJ4pihr-BRsxsUbXDEINcItsHcZcU1F_T2rnxTa6A_6GqkE4xJ6IfEM4bfJ39twzw";

    //Trondheim : lat= 63.434464  lon = 10.387573 zoom=12
    double mapLat = 63.430;
    double mapLon = 10.4;
    double zoom = 12;
    double userLat = 63.435;
    double userLon = 10.4;
    string userHtml;

    double busDepLat = 63.435;
    double busDepLon = 10.43;
    string busDepAddress = "";
    string busEscapedDepAddress = "";
    string busDepHtml;
    double busArrLat;// = 63.437;
    double busArrLon;// = 10.45;
    string busArrAddress = "";
    string busEscapedArrAddress = "";
    string busArrHtml;
    double libLat;// = 63.438;
    double libLon;// = 10.46;
    string libHtml;
    string busFrom;
    string busTo;
    string busLineFirst;
    string busLineSecond;
    string busDepartureTime;
    string busTransferPoint;
    Library selectedLibrary;
    //used to convert from point to address
    static string responseResult;
    static string url;
    string escapedLibraryAddress;

    ApplicationServer appServ;


    protected void Page_Load(object sender, EventArgs e)
    {
        Culture = System.Globalization.CultureInfo.InvariantCulture.ToString();
        appServ = ApplicationServer.Instance;
    }

    protected void genreateBubbleContent()
    {
        userHtml = @"<div><strong>User Position</strong><br />This is the users position</div>";
        busArrHtml = @"<div><strong>Arrival</strong><br />The bus arrives at " + busEscapedArrAddress + @"</div>";
        if (!string.IsNullOrEmpty(busLineSecond) && !string.IsNullOrEmpty(busTransferPoint))
        {
            busDepHtml = @"<div><strong>From " + busEscapedDepAddress + @"</strong><br />Line " + busLineFirst + ", at: " + busDepartureTime + @"</div><div>Transfer to line " + busLineSecond + " when at " + busTransferPoint + @"</div>";
        }
        else
        {
            busDepHtml = @"<div><strong>From " + busEscapedDepAddress + @"</strong><br />Line " + busLineFirst + ", at: " + busDepartureTime + @"</div>";
        }
        Library currentLib = (Library)appServ.applicationLibraryHash[Request.QueryString["libID"]];
        libHtml = currentLib.generateMyBubleInfo();
    }

    protected void updateParametersFromUrl()
    {
        //Checks if a libraryID is given, and returns the coresponding library object
        selectedLibrary = null;
        String[] busSchedules = null;
        if (Request.QueryString["libID"] != null)
        {
            selectedLibrary = (Library)appServ.applicationLibraryHash[Request.QueryString["libID"]];
            escapedLibraryAddress = selectedLibrary.address.Replace("'", @"\'");
            libLat = selectedLibrary.lat;
            libLon = selectedLibrary.lon;
            //Transform user from coorindate to address
            busFrom = Session["addressID"].ToString();
            busTo = selectedLibrary.address;
            busSchedules = appServ.busSearch(busFrom, busTo);
            if (busSchedules != null)
            {
                busDepAddress = busSchedules[0];
                busEscapedDepAddress = busDepAddress.Replace("'", "\'");
                busArrAddress = busSchedules[5];
                busEscapedArrAddress = busArrAddress.Replace("'", @"\'");
                busLineFirst = busSchedules[1];
                busLineSecond = busSchedules[3];
                busDepartureTime = busSchedules[2];
                busTransferPoint = busSchedules[4];
            }
            else
            {
                Session["error"] = "No bus schedules available";
                Response.Redirect("MainMenu.aspx", true);
                return;
            }
        }

        #region OptionalSettingsRegion
        //Checks if a specific lat,lon or zoom is request. If not, the default values are used
        if (Request.QueryString["lat"] != null)
        {
            userLat = double.Parse(Request.QueryString["lat"]);
        }
        if (Request.QueryString["lon"] != null)
        {
            userLon = double.Parse(Request.QueryString["lon"]);
        }
        if (Request.QueryString["zoom"] != null)
        {
            zoom = double.Parse(Request.QueryString["zoom"]);
        }
        if (Request.QueryString["userLat"] != null)
        {
            userLat = double.Parse(Request.QueryString["userLat"]);
        }

        if (Request.QueryString["userLon"] != null)
        {
            userLon = double.Parse(Request.QueryString["userLon"]);
        }
        #endregion
    }

    protected string genereateHeader()
    {
        string returnString = @"<script src='http://maps.google.com/maps?file=api&amp;v=2&amp;sensor=false&amp;key=" + API_KEY + @"'
            type='text/javascript'>
            </script>
            <script type='text/javascript'>
";
        return returnString;
    }

    protected string decleareVariables()
    {
        string returnString = @"
    var map;

    var firstDirections;
    var secondDirections;

    var geocoderUser;
    var geocoderDepBus;
    var geocoderArrBus;
    var geocoderLib;

    var tempPosName;
    var userPosName = '" + busFrom + @", Trondheim, Norway';
    var busDepPosName = '" + busEscapedDepAddress + @", Trondheim, Norway';
    var busArrPosName = '" + busEscapedArrAddress + @", Trondheim, Norway';
    var libPosName = '" + escapedLibraryAddress + @", Trondheim, Norway';

    var userToDepartureString;
    var arrivalToLibraryString;
    
    var depBusMarker;
    var userMarker;
    var arrBusMarker;
    var libMarker;

    var userHtml;
    var busDepHtml;
    var busArrHtml;
    var libHtml;";

        return returnString;
    }

    /// <summary>
    /// Generate callBack handlers, the methods the google maps server calls when an geographical point is transformed from <lat,lng> til an address.
    /// </summary>
    /// <returns>string callbackhandlers</returns>
    protected string generateCallBackhandlers()
    {
        string returnString = @"
           function callBackUserHandler(response){
        }
        function callBackArrBusHandler(response){
      }
    ";

        return returnString;

    }

    /// <summary>
    /// The method genreates the methods necesarry for opening the info windows on each of the GMarkers.
    /// These are the methods called on the click event on each of the markers.
    /// </summary>
    /// <returns></returns>
    protected string openInfoWindows()
    {
        string returnString = @"
            function openArrivalInfo(){
                arrBusMarker.openInfoWindowHtml(busArrHtml);
            }
            function openDepInfo(){
                depBusMarker.openInfoWindowHtml(busDepHtml);
            }

            function openUserInfo(){
                 userMarker.openInfoWindowHtml(userHtml);
            }
              function openLibInfo() {
                libMarker.openInfoWindowHtml(libHtml);
            }";

        return returnString;

    }

    /// <summary>
    /// Update the markers for each of the Markers, and adds the 'click' event to each of them
    /// </summary>
    /// <returns></returns>
    protected string updateRouteMarkers()
    {
        string returnString = @"
        function updateSecondRouteMarkers(){
            arrBusMarker = secondDirections.getMarker(1);
            arrBusMarker.setImage('http://folk.ntnu.no/bjarnesl/yatta/bus2.png');
            GEvent.addListener(arrBusMarker, 'click', openArrivalInfo);
            libMarker =   secondDirections.getMarker(0);
            libMarker.setImage('http://folk.ntnu.no/bjarnesl/yatta/ntnuLogo.png');
            GEvent.addListener(libMarker, 'click', openLibInfo);
            document.getElementById('disclaim').innerHTML = '';
        }
        function updateFirstRouteMarkers(){
            depBusMarker = firstDirections.getMarker(1);
            depBusMarker.setImage('http://folk.ntnu.no/bjarnesl/yatta/bus2.png');
            GEvent.addListener(depBusMarker, 'click', openDepInfo);
            userMarker = firstDirections.getMarker(0);
            userMarker.setImage('http://folk.ntnu.no/bjarnesl/yatta/userFrontView.png');
            GEvent.addListener(userMarker, 'click', openUserInfo);
            document.getElementById('disclaim').innerHTML = '';
        }";

        return returnString;
    }

    /// <summary>
    /// These methods are called on the callback when coordinates has for the library and the departing bus has been created
    /// </summary>
    /// <returns></returns>
    protected string routeCallBackhandlers()
    {
        string returnString = @"
    //Not sure if this function is required, as the address is fetched from the local database.
    function callBackLibHandler(response){

   }

   
";


        return returnString;
    }

    protected string initializeMap()
    {
        string returnString = @"function initialize() {
        if(GBrowserIsCompatible()) {
            //Setting up the map.
            map = new GMap2(document.getElementById('map_canvas'));
            map.setCenter(new GLatLng(63.430,10.4), 14);

            //Setting up buble content
                userHtml = '" + userHtml.ToString() + @"';
                busDepHtml = '" + busDepHtml.ToString() + @"';
                busArrHtml = '" + busArrHtml.ToString() + @"';
                libHtml = '" + libHtml.ToString() + @"';
            
//         Converting GeopPoints and textual addresses
           
//         Handling departure bus
                userToDepartureString = 'from: ' + userPosName + ' to: ' + busDepPosName;
                var directionsPanel = document.getElementById('disclaim');

                firstDirections = new GDirections(map,directionsPanel);
                firstDirections.load(userToDepartureString,{travelMode:G_TRAVEL_MODE_WALKING,preserveViewport:true});         
                GEvent.addListener(firstDirections, 'addoverlay', updateFirstRouteMarkers);
                
                
//                Handling arrival bus
                arrivalToLibraryString = 'from: ' + libPosName + ' to: ' + busArrPosName;
                secondDirections = new GDirections(map,directionsPanel); 
                secondDirections.load(arrivalToLibraryString, {travelMode:G_TRAVEL_MODE_WALKING, preserveViewport:true });
                GEvent.addListener(secondDirections, 'addoverlay', updateSecondRouteMarkers);
}
    }";
        return returnString;
    }

    /// <summary>
    /// The method generate the footer of the javacsript, e.g. closing the script tag
    /// </summary>
    /// <returns></returns>
    protected string generateFooter()
    {
        string returnString = @"
            function focusOnUser()
            {
                panTo(userMarker);
            }
            function focusOnTarget()
            {
                panTo(libMarker);
            }
            
        </script>";
        return returnString;
    }

    /// <summary>
    /// This method returns the javascript used to create the map
    /// </summary>
    /// <returns>String JavasScript</returns>
    protected string generateJavaScript()
    {
        string returnString = "";

        updateParametersFromUrl();
        genreateBubbleContent();

        //These calls generates the javascript
        returnString += genereateHeader();
        returnString += decleareVariables();
        returnString += generateCallBackhandlers();
        returnString += openInfoWindows();
        returnString += updateRouteMarkers();
        returnString += routeCallBackhandlers();
        returnString += initializeMap();
        returnString += generateFooter();
        return returnString;
    }

    public string getUserAddress(string[] coorindatesArray)
    {
        string str;
        string user;
        string lat = coorindatesArray[1];
        string lon = coorindatesArray[2];
        string time;
        url = @"http://napp.fiskekulpen.com/ubit/convertpoint.aspx?lat=" + lat.Replace(',', '.') + "&lon=" + lon.Replace(',', '.');
        string responseResult = "";
        //The following code will not execute the javacript
        HttpWebRequest webRequest = WebRequest.Create(url) as HttpWebRequest;
        webRequest.KeepAlive = true;
        webRequest.Method = "POST";
        webRequest.ContentType = "application/x-www-form-urlencoded";
        StreamReader responseReader = new StreamReader(webRequest.GetResponse().GetResponseStream(), Encoding.UTF7);
        responseResult = responseReader.ReadToEnd();
        responseReader.Close();



        return responseResult;
    }
    public string zoomToUbit()
    {
        return "map.panTo(libMarker.getLatLng())";
    }

    protected void ImageButton1_Click(object sender, ImageClickEventArgs e)
    {
        Response.Write("map.panTo(libMarker.getLatLng())");
    }
}
