﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.WindowsMobile.Samples.Location;
using System.Net;
using System.IO;


namespace masterGPSWindowsMobile
{
    public partial class Form1 : Form
    {

        Gps gps = new Gps();
        GpsDeviceState device = null;
        GpsPosition position = null;
        System.EventHandler updateDataHandler;
        int fetchCount = 0;

        HttpWebRequest webRequest;
        public Form1()
        {
            InitializeComponent();

            gps.Open();
        }

        private void Form1_Load(object sender, EventArgs e)
        {

            updateDataHandler = new System.EventHandler(UpdateData);
            gps.DeviceStateChanged += new Microsoft.WindowsMobile.Samples.
            Location.DeviceStateChangedEventHandler(gps_DeviceStateChanged);
            gps.LocationChanged += new Microsoft.WindowsMobile.Samples.
            Location.LocationChangedEventHandler(gps_LocationChanged);

        }

        protected void gps_LocationChanged(object sender,
                                    LocationChangedEventArgs args)
        {
            position = args.Position;
            Invoke(updateDataHandler);
        }

        protected void UpdateData(object sender, System.EventArgs args)
        {
            fetchCount++;
            if (gps.Opened)
            {
                string localLat = "";
                string localLon = "";
                // verify that the device object is not null
                if (device != null)
                {
                }

                // verify that the position object is not null
                if (position != null)
                {
                    //The position object exposes
                    // additional properties that indicate 
                    //which properties are currently valid.
                    if (position.LatitudeValid)
                    {
                        localLat = position.Latitude.ToString();
                        latLabel.Text = localLat;
                    }
                    if (position.LongitudeValid)
                    {
                        localLon = position.Longitude.ToString();
                        lonLabel.Text = localLon;
                    }
                    serviceLabel.Text = "Satellites in view: " + position.SatellitesInViewCount;
                }
                webRequest = WebRequest.Create("http://napp.fiskekulpen.com/ubit/gpsHandler.aspx?user=bigB&lat=" + localLat + "&lon=" + localLon) as HttpWebRequest;
                ((HttpWebRequest)this.webRequest).AllowWriteStreamBuffering = true;
                webRequest.KeepAlive = false;
                webRequest.Method = "POST";
                webRequest.ContentType = "applications/x-www-form-urlencoded";
                StreamWriter sw = new StreamWriter(webRequest.GetRequestStream());
                sw.Close();
                label3.Visible = true;
                StreamReader sr = new StreamReader(webRequest.GetResponse().GetResponseStream());
                string response = sr.ReadToEnd();
                statusLabel.Text = "Registrations: " + fetchCount;
                sr.Close();
            }
        }
        protected void gps_DeviceStateChanged(Object sender, DeviceStateChangedEventArgs args)
        {
        }

        private void menuItem1_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void LatitudeLabel_ParentChanged(object sender, EventArgs e)
        {

        }

        private void webBrowser1_DocumentCompleted(object sender, WebBrowserDocumentCompletedEventArgs e)
        {

        }
    }
}